package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.RmsCapacity;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface RmsCapacityMapper extends IBaseMapper<RmsCapacity, BigDecimal> {
   //展示运力信息
    List<Map<String, Object>> getCapacityList(Map<String, Object> mapVal);

    //根据运力id获取运力信息
    List<Map<String, Object>> getCapacityById(BigDecimal id);

    //运力下拉框
    List<Map<String,Object>> getCapacityTypeId();

    //运力id自增
    @Select("select seq_RMS_CAPACITY.nextval from dual")
    BigDecimal selectCapacityId();

   //承运商下拉框
    List<Map<String, Object>> getCarrierId();

    //通过车牌号查询是否存在重复值
    Integer selectBycapacityNumber(String number);

   //根据ssoId查询承运商名称
    Map<String, Object> getCarrierNameBySSOId(String carrierSSOId);

    //根据运力id查找ssoId
    String ssoIdBycapacityId(BigDecimal id);

 //逻辑删除
 int updateCapacityCarrier(@Param("capacityId") String capacityId,@Param("carrierSSOId")  String carrierSSOId);

 List<Map<String, Object>> getCapacityByCapacityId(Integer id);
}