package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.RmsWarehouseMapper;
import com.steerinfo.dil.model.RmsShipper;
import com.steerinfo.dil.model.RmsWarehouse;
import com.steerinfo.dil.service.IRmsWarehouseService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * RmsWarehouse服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-11-10 02:04
 * 类描述
 * 修订历史：
 * 日期：2021-11-10
 * 作者：generator
 * 参考：
 * 描述：RmsWarehouse服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "rmsWarehouseService")
public class RmsWarehouseServiceImpl  implements IRmsWarehouseService {

    @Autowired
    private RmsWarehouseMapper rmsWarehouseMapper;

    /*
    * 显示原料工厂
    * */
    @Override
    public List<Map<String, Object>> getWarehouseList(Map<String, Object> mapVal) {
        return rmsWarehouseMapper.getWarehouseList(mapVal);
    }
    /*
    * 增加原料工厂
    * */
    @Override
    public int insertWarehouse(Map<String,Object> rmsWarehouse) {
        RmsWarehouse rmsWarehouse1=new RmsWarehouse();
        String warehouseName =(String) rmsWarehouse.get("warehouseName");
        BigDecimal shipperId = DataChange.dataToBigDecimal(rmsWarehouse.get("shipperId"));
        String userId=(String) rmsWarehouse.get("userId");
        //根据仓库名称查找装货点是否存在于数据库中
        BigDecimal searchNum = rmsWarehouseMapper.searchWarehouseName(warehouseName,shipperId);
        if (searchNum==null) {
            rmsWarehouse1.setDeleted(new BigDecimal(0));
            if (userId!=null) {
                rmsWarehouse1.setInsertUsername(userId);
            }
            rmsWarehouse1.setInsertTime(new Date());
            rmsWarehouse1.setWarehouseId(rmsWarehouseMapper.selectWarehouseId());
            return rmsWarehouseMapper.insertSelective(rmsWarehouse1);
        }else {
            return -1;
        }
    }
    /*
    * 更改原料工厂
    * */
    @Override
    public int updateWarehouse(RmsWarehouse rmsWarehouse) {
        rmsWarehouse.setUpdateUsername("admin");
        rmsWarehouse.setUpdateTime(new Date());

        return rmsWarehouseMapper.updateByPrimaryKeySelective(rmsWarehouse);
    }
    /*
    * 删除原料工厂
    * */
    @Override
    public int deleteWarehouse(BigDecimal id) {
        RmsWarehouse rmsWarehouse=rmsWarehouseMapper.selectByPrimaryKey(id);
        rmsWarehouse.setDeleted(new BigDecimal(1));
        return rmsWarehouseMapper.updateByPrimaryKeySelective(rmsWarehouse);
    }

    /**
     * 根据id查询原料工厂
     * @param id
     * @return
     */
    @Override
    public Map<String, Object> getWarehouseById(BigDecimal id) {
        return rmsWarehouseMapper.getWarehouseById(id);
    }

    @Override
    public List<Map<String, Object>> getWarehouseTypeId() {
        return rmsWarehouseMapper.getWarehouseTypeId();
    }

    @Override
    public List<Map<String, Object>> getPortId() {
        return rmsWarehouseMapper.getPortId();
    }


    /*
    展示港存堆场
     */
    @Override
    public List<Map<String, Object>> getYardList(Map<String, Object> mapVal) {
        return rmsWarehouseMapper.getYardList(mapVal);
    }
}
